// AmbulantPlayerView.h : interface of the CAmbulantPlayerView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_AMBULANTPLAYERVIEW_H__39E37311_AA72_400D_BB0A_5145222534D7__INCLUDED_)
#define AFX_AMBULANTPLAYERVIEW_H__39E37311_AA72_400D_BB0A_5145222534D7__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class CAmbulantPlayerView : public CView
{
protected: // create from serialization only
	CAmbulantPlayerView();
	DECLARE_DYNCREATE(CAmbulantPlayerView)

// Attributes
public:
	CAmbulantPlayerDoc* GetDocument() const;

	void SetMMDocument(LPCTSTR lpszPathName);
	UINT_PTR m_timer_id;
	CString m_curDocFilename;
	CString m_curFilter;
	UINT m_cursor_id;
	bool m_autoplay;

	// Calling Enable() on toolbar buttons will always cause a redraw,
	// even if nothing changes. Therefore, we cache the previous state.
	bool m_was_play_enabled;
	bool m_was_pause_enabled;
	bool m_was_pause_active;
	bool m_was_stop_enabled;
	bool m_was_viewsource_enabled;
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAmbulantPlayerView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CAmbulantPlayerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CAmbulantPlayerView)
	afx_msg void OnPlay();
	afx_msg void OnUpdatePlay(CCmdUI* pCmdUI);
	afx_msg void OnPause();
	afx_msg void OnUpdatePause(CCmdUI* pCmdUI);
	afx_msg void OnStop();
	afx_msg void OnUpdateStop(CCmdUI* pCmdUI);
	afx_msg void OnDestroy();
	afx_msg void OnChar(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnHelpWelcome();
	afx_msg void OnFileSelect();
	afx_msg void OnFileLoadSettings();
	afx_msg void OnPreferences();
	afx_msg void OnViewSource();
	afx_msg void OnUpdateViewSource(CCmdUI* pCmdUI);
	afx_msg void OnViewLog();
	afx_msg LPARAM OnReplaceDoc(WPARAM wParam, LPARAM lParam);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in AmbulantPlayerView.cpp
inline CAmbulantPlayerDoc* CAmbulantPlayerView::GetDocument() const
   { return (CAmbulantPlayerDoc*)m_pDocument; }
#endif

extern CAmbulantPlayerView *mainAmbulantWindow;

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft eMbedded Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AMBULANTPLAYERVIEW_H__39E37311_AA72_400D_BB0A_5145222534D7__INCLUDED_)
